


CaS(1)                   CaS manual page                   CaS(1)


NAME
       CaS - Casio Caculator data wrangling tool

SYNOPSIS
       CaS  [-i=format,args]  infile  [-l=format] [-o=format,args
       outfile] [-t] [-c=conv,args] [-C=conv,args] [-v] [-d=file]

DESCRIPTION
       CaS  Reads and writes Casio Calculator related data to and
       from a variety of formats, including Calculator Text  For-
       mat  and  serial communication with the calculator itself.
       CaS is also capable of transforming the data, for  example
       it is possible to read in a screenshot, and output this as
       a program which draws the same picture on  the  calculator
       screen.

SUPPORTED FILE FORMATS
       CaS currently supports the following file formats

       ctf  Calculator  Text  Format.  A text only representation
            of calculator programs, data and screenshots.

       cas  CAS binary files.  Data in these is as stored  inter-
            nally  by  the  calculator and as transmitted accross
            serial links.

       gif  (write only)  Graphics Interchange Format.   Suitable
            for screenshot data

       bmp  Windows  bitmaps.   Read and write medium for screen-
            shots

       fxp  FXP files as used in the Qbasic program  FXP  by  Bob
            Parish.  Used for single programs.

       bin  Untyped binary files.  Of limited normal use.

            CaS can also send and receive files directly from the
            calculator via a serial interface cable.

SUPPORTED DATA TYPES
       CaS currently supports the following data types:

       OldProg
            Unnamed programs, as featured on the 7700,  9700  and
            9800 calculators.  Both in single and multiple forms.

       Editor
            Editor files on the 9700 and 9800;  programs  on  the
            9750,  9850  and 9950 calculators.  These are distin-
            guished from `OldProg' in having names and passwords.

       SSMono
            Monochrome  screenshots.  Both 9700 and 9800 ordering



                          19 April 1997                         1





CaS(1)                   CaS manual page                   CaS(1)


            are supported.

       SSCol
            Colour screenshots.  (9800 only at present).

       Raw  Raw data.  This type is used by CaS to store any data
            which is not understood, ie any data not in the above
            list of types.  For hackers.

       Text Plain text.  This type is a side effect  of  the  CTF
            specifications,  and  is used by CaS to store unknown
            data read from a CTF file.  The type  `Text'  can  be
            used in CTF to mark off portions as large comments --
            for program descriptions, instructions and the  like.



OPTIONS
       -h, -?, --help
            Options listing

       -V, --version
            Prints version


       -i[=args], --input[=args], --infile[=args] filename
            Specifies  the  input  file.   Use `-' or `stdin' for
            standard input.  Implicitly defined for a bare  file-
            name,  and so only required if certain arguments must
            be set.  For serial communications, `filename' should
            be  the name of the serial port to ehich the calcula-
            tor is attached, examples being COM2  under  DOS  and
            /dev/ttyS1 under Unix systems.


       -o[=args], --output[=args], --outfile[=args] filename
            Specifies the output file.  As above, `-' or `stdout'
            may be used for standard  output.   `stderr'  may  be
            used  for  standard  error,  but  usage of stderr for
            files is discouraged.  There  is  no  default  output
            filename, and bare filenames are always assumed to be
            input files, so must be used when specifying an  out-
            put file.


       -l[=args], --list[=args]
            Instructs  CaS  to  list the file to standard output.
            Note that many formats when listed are  different  to
            CTF,  even though at a first glance they appear simi-
            lar.  List  output  is  generally  more  readable  to
            humans, but can be ambiguous to a computer.






                          19 April 1997                         2





CaS(1)                   CaS manual page                   CaS(1)


       -m=MODEL, --model=MODEL
            Sets  the  calculator model being used.  Valid values
            for MODEL are: 7700, 9700, 9800,  9750,  9850,  9950,
            all.   The default value is all which may often yield
            incorrect output for programs, especially  for  those
            written for higher model calculators.


       -c=from-to[,args], --convert=from-to[,args]

       -C=from-to[,args], --convert-after=from-to[,args]
            Specify any conversions from particular data types to
            other types.  If --convert-after is used then conver-
            sion   is  performed  after  list  output,  otherwise
            before.  See the conversions section for more  infor-
            mation.


       -t, --terse
            Produce  a terse listing of the contents of the file.
            This is the default  action  if  neither  --list  nor
            --output are specified.


       -v, --verbose
            Display verbose information about the progress of CaS
            to standard output.


       -d[=file], --debug[=file]
            display debugging information on the progress of CaS.
            can  be useful for debugging both CaS and th entities
            with which CaS is working (eg the serial link).  If a
            file is specified then the debugging information goes
            to that file, otherwise to stdout.   Note  that  some
            messages  emitted  by  CaS are also sent to the debug
            stream, so if a file is not specified then there will
            be duplication in the output.


       -p, --pager
            Use  a pager on CaS's output.  Set to every 20 lines,
            but future versions of CaS  will  make  this  config-
            urable.


       -e=file, --castle=file
            Specify  the output file for castle progress informa-
            tion.  castle is a  developmental  Windoze  front-end
            for  CaS.   The information in this file is to inform
            castle on exactly  what  CaS  did.   Incomplete,  and
            variable between versions.  Not useful for end-users.





                          19 April 1997                         3





CaS(1)                   CaS manual page                   CaS(1)


ARGUMENTS
       The --input, --output, --list,  --convert  and  --convert-
       after  have  a  number  of  options  which  control  their
       behaviour.  There are four types of options:


       flags
       Flags are set by simply adding the flag name to the  argu-
       ment  list.   They  can be un-set by preceeding their name
       with `no-'.  eg --output=com,rts,no-dtr


       string values
       These consist simply of  the  format  `arg=value'.   Often
       used  for  filenames,  such as `--list,tokfile=cp437.tok'.
       `:' may also be used in place of `='.


       numerical values
       These are entered in the same way as string  values.   The
       base  can  be specified using the normal `C' syntax.  Num-
       bers starting with `0' are interpreted in  octal,  numbers
       beginning  with  `0x' are considered to be in hexadecimal,
       and all other numbers are taken to be in decimal.


       character values
       Perhaps surprisingly, the default method  for  entering  a
       character  value  is  as a number as above.  To specify an
       actual character, say the letter `a', the letter should be
       prefixed  with  `$'.  For example: --list,empty=32,full=$#
       will use a space (ASCII value 32) for an empty pixel,  and
       a  # for a full one.  This methodology allows the specifi-
       cation of non-printing characters.

       ARGUMENT LIST


       glossary
            Makes CaS insert a glossary of un-obvious  tokens  at
            the  beginning  of program data in a CTF output file.
            Should be used when distributing programs in CTF for-
            mat.


       nice Makes  CaS  output  nicer  tokens when writing a .ctf
            file.   Examples  of  `nicer'  tokens  include  using
            `sqrt'  instead  of  `\sqrt'  in  programs (except in
            strings).  `nice' tokens also include spacing  around
            operators  such  as  `+'  and  allows  `^2 ' to match
            `\sqr'.  Note the space after  `^2',  this  preserves
            ambiguity from operations such as `X^21'





                          19 April 1997                         4





CaS(1)                   CaS manual page                   CaS(1)


       inverse
            Used  with  screenshots,  inverts  the  colours where
            specified.  This argument may be used  with  --input,
            --list and --output.  Note that use of `inverse' with
            --input will of  course  affect  the  data  used  for
            --list and --output.


       overwrite, over
            When  sending  programs to the calculator, causes any
            existing programs in the target slot to be  overwrit-
            ten.


       space
            Inserts  a space in list output between every program
            `token'.  Can be useful to check that CaS is  parsing
            CTF files correctly.


       num={dec, hex, oct}
            Add  the  `ctoken'  number for each token in the list
            output.  debugging options.  `dec', `hex'  and  `oct'
            stand  for  decimal,  hexadecimal  and  octal respec-
            tively.


       password, pw
            Make CaS display the password for  Editor  blocks  in
            the list output header.  Default is off in case some-
            one is looking over your shoulder.


       dump Make --list dump the raw data to the screen as stored
            in  CaS's memory rather than nicely readable and for-
            matted.  Debugging option.

       shownext
            Used with `dump', this displays the next item in mem-
            ory  after  the  data section of the dump.  Debugging
            option with the possibility of segfaulting.


       crop[=width]
            When listing screenshots,  causes  the  lines  to  be
            cropped at `width' characters to avoid nasty wrapping
            effects.  Default width is 79.


       double
            Lists screenshots with  two  calculator  lines  being
            represented  by one line on the terminal.  Only works
            with monochrome screenshots.




                          19 April 1997                         5





CaS(1)                   CaS manual page                   CaS(1)


       linenos
            Displays line numbers in screenshot  listings.   Note
            that  when  used  in conjunction with `crop' that the
            width of the numbers is taken into account.


       top=CHAR

       bottom=CHAR, bot=CHAR

       full=CHAR

       empty=CHAR, blank=CHAR
            Set the characters used  to  display  pixels  on  the
            screen  for  monochrome screenshots.  `top' and `bot-
            tom' are only used in conjunction with  the  `double'
            argument.


       red=CHAR

       green=CHAR

       blue=CHAR

       empty=CHAR, blank=CHAR
            Set  the  charcters  used to represent colour screen-
            shots on the terminal.  colours on the  terminal  are
            not currently supported, neither is `double'.


       7700, 9700, 9800

       9750, 9850, 9950
            When  reading/writing .CAS files, or when communicat-
            ing via serial cable, force the format to  be  either
            old  style  (7700,  9700,  9800)  or new style (9750,
            9850, 9950).  Normally the format is autodetected  on
            input,  and  the  default  format to use on output is
            determined by the --model option.


       order={9700, 9800}
            When writing a screenshot to a .CAS file, specify the
            ordering  to  be used.  Either bad old 9700 style, or
            good new 9800 style may be chosen.


       raw  Set the reading of .CAS files or serial data to  raw.
            This  means that the data will be read as binary data
            and CaS will not attempt to understand it.   Normally
            if  CaS  cannot understand the data then this mode is
            used automatically.




                          19 April 1997                         6





CaS(1)                   CaS manual page                   CaS(1)


       status
            For .CAS or serial communications, but  more  usefull
            for  serial comms.  This option displays the sizes of
            file blocks successfully sent or received.


       bytes
            Serial comms.  Displays every byte of  data  sent  or
            received over the serial line.  Also useful for slow-
            ing down the rate of communication (!)


       pause
            Serial comms.  Causes CaS to pause and wait for  user
            intervention  before actually sending data.  Obsoles-
            cent now as CaS will now retry if the  calculator  is
            not ready.


       inline
            Serial  comms.   Makes  CaS  send or receive the data
            to/from a Send( or Receive( command on a  9750,  9850
            or 9950.  Not very reliable at the moment.


       parity={even, odd, none}
            Sets  the  parity.  The individual values can also be
            used as flags on their own.


       baud={1200, 2400, 4800, 9600}
            Sets the baud rate.  Note that  the  9750,  9850  and
            9950  calculators  are fixed to baud=9600,parity=even
            which is the internal default for CaS.


       rts  Raise the RTS  line  on  the  serial  port.   May  be
            required  to  power interface circuitry on the serial
            cable.


       dtr  Raise the DTR line on the  serial  port.   Note  that
            `rts'  and  `dtr' are not operational under Unix, but
            my cable seems to work anyway.


CONVERSIONS
       SSMono-OldProg
            Converts a screenshot into a program which will  draw
            the screenshot on the calculator.


FILES
       Under  DOS  the  following files should all be kept in the



                          19 April 1997                         7





CaS(1)                   CaS manual page                   CaS(1)


       same directory as `cas.exe'.

       /etc/system.casrc
       System wide CaS defaults file.  Named `cas.ini' under DOS.

       ${HOME}/.casrc
       User  defaults  file.   This  overrides  the  system  wide
       defaults file when present.  Non-existant in DOS setups.

       /usr/local/lib/cas/ctf.tok
       Token file for Casio Text Format.  Other token  files  may
       also reside in this directory.


BUGS
       Probably.

       Most of the bugs will be due to the contortions present in
       CaS to deal with Casio's braindeadness.


AUTHOR
       CaS was written by Tom Wheeley <tw104@york.ac.uk>.

       Tom Lynn <thl22@cam.ac.uk> helped write ctf.tok.
































                          19 April 1997                         8


